package org.greenstone.gsdl3.gs3build.database;
  
import java.util.List;
import java.util.ArrayList;


public class GS3SQLCreateTable
{ 
    String tableName;
    List   properties;
    List   primaryKey;
    List   indexed;

    public GS3SQLCreateTable(String tableName)
    { 
	this.tableName = tableName;
	this.properties = new ArrayList();
	this.primaryKey = new ArrayList();
	this.indexed    = new ArrayList();
    }
    
    public void addAutoPrimaryKey(String fieldName)
    {
	GS3SQLField field = new GS3SQLField(fieldName, GS3SQLField.AUTOINTEGER_TYPE);
	this.properties.add(field);
	this.setPrimaryKey(fieldName);
    }

    public void addProperty(String fieldname)
    { 
	GS3SQLField field = new GS3SQLField(fieldname);
	this.properties.add(field);
    }
    
    public void addProperty(String fieldname, String type)
    { 
	GS3SQLField field = new GS3SQLField(fieldname, type);
	this.properties.add(field);
    }

    public void addProperty(String fieldname, int length)
    { 
	GS3SQLField field = new GS3SQLField(fieldname, length);
	this.properties.add(field);
    }

    public void setPrimaryKey(String fieldname)
    { 
	this.primaryKey.clear();
	this.primaryKey.add(fieldname);
    }

    public void extendPrimaryKey(String fieldname)
    { 
	this.primaryKey.add(fieldname);
    }
    
    public void addIndex(String fieldname)
    { 
	this.indexed.add(fieldname);
    }

    public String toString()
    {	
	StringBuffer reply = new StringBuffer();
	
	reply.append("CREATE TABLE ");
	reply.append(this.tableName);
	reply.append(" (");
	for (int f = 0; f < this.properties.size(); f ++) {
	    GS3SQLField field = (GS3SQLField) this.properties.get(f);
	    if (f != 0) {
		reply.append(",");
	    }
	    reply.append(field.toString());
	}

	for (int p = 0; p < this.primaryKey.size(); p ++) {
	    if (p == 0){
		reply.append(", PRIMARY KEY(");
	    }
	    else {
		reply.append(",");
	    }
	    reply.append(this.primaryKey.get(p).toString());
	    
	    if (p == this.primaryKey.size() - 1) {
		reply.append(")");
	    }
	}
	// TODO: add primary key, index etc. notations
	reply.append(");");
	
	return reply.toString();
    }
}
